"""
    The Plaid API

    The Plaid REST API. Please see https://plaid.com/docs/api for more details.  # noqa: E501
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from plaid.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from plaid.model.country_code import CountryCode
    from plaid.model.institution_status import InstitutionStatus
    from plaid.model.payment_initiation_metadata import PaymentInitiationMetadata
    from plaid.model.products import Products
    globals()['CountryCode'] = CountryCode
    globals()['InstitutionStatus'] = InstitutionStatus
    globals()['PaymentInitiationMetadata'] = PaymentInitiationMetadata
    globals()['Products'] = Products


class Institution(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'institution_id': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'products': ([Products],),  # noqa: E501
            'country_codes': ([CountryCode],),  # noqa: E501
            'routing_numbers': ([str], none_type,),  # noqa: E501
            'oauth': (bool,),  # noqa: E501
            'url': (str, none_type,),  # noqa: E501
            'primary_color': (str, none_type,),  # noqa: E501
            'logo': (str, none_type,),  # noqa: E501
            'status': (InstitutionStatus,),  # noqa: E501
            'payment_initiation_metadata': (PaymentInitiationMetadata,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'institution_id': 'institution_id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'products': 'products',  # noqa: E501
        'country_codes': 'country_codes',  # noqa: E501
        'routing_numbers': 'routing_numbers',  # noqa: E501
        'oauth': 'oauth',  # noqa: E501
        'url': 'url',  # noqa: E501
        'primary_color': 'primary_color',  # noqa: E501
        'logo': 'logo',  # noqa: E501
        'status': 'status',  # noqa: E501
        'payment_initiation_metadata': 'payment_initiation_metadata',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, institution_id, name, products, country_codes, routing_numbers, oauth, *args, **kwargs):  # noqa: E501
        """Institution - a model defined in OpenAPI

        Args:
            institution_id (str): Unique identifier for the institution
            name (str): The official name of the institution
            products ([Products]): A list of the Plaid products supported by the institution. Note that only institutions that support Instant Auth will return `auth` in the product array; institutions that do not list `auth` may still support other Auth methods such as Instant Match or Automated Micro-deposit Verification. For more details, see [Full Auth coverage](https://plaid.com/docs/auth/coverage/).
            country_codes ([CountryCode]): A list of the country codes supported by the institution.
            routing_numbers ([str], none_type): A partial list of routing numbers associated with the institution. This list is provided for the purpose of looking up institutions by routing number. It is not comprehensive and should never be used as a complete list of routing numbers for an institution.
            oauth (bool): Indicates that the institution has an OAuth login flow. This is primarily relevant to institutions with European country codes.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            url (str, none_type): The URL for the institution's website. [optional]  # noqa: E501
            primary_color (str, none_type): Hexadecimal representation of the primary color used by the institution. [optional]  # noqa: E501
            logo (str, none_type): Base64 encoded representation of the institution's logo. [optional]  # noqa: E501
            status (InstitutionStatus): [optional]  # noqa: E501
            payment_initiation_metadata (PaymentInitiationMetadata): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.institution_id = institution_id
        self.name = name
        self.products = products
        self.country_codes = country_codes
        self.routing_numbers = routing_numbers
        self.oauth = oauth
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
